/**
* \file
* dcf77.h
* \brief
* access the dcf77 time module (DCF-2 ELV)
*/


#ifndef _DCF77_H
#define _DCF77_H


#define DCF77_PWR PD0
#define DCF77_DDRPWR DDRD
#define DCF77_PORTPWR PORTD
#define DCF77_IRQ PD2 //INT0/PCINT18 (in case of a change, c-file needs to be changed, too)
#define DCF77_DDRIRQ DDRD
#define DCF77_PORTIRQ PORTD
#define DCF77_PINIRQ PIND

#define DCF77_MINUTE_OK 1
#define DCF77_HOUR_OK 2
#define DCF77_DAY_OK 4
#define DCF77_WEEKDAY_OK 8
#define DCF77_MONTH_OK 16
#define DCF77_YEAR_OK 32
#define DCF77_ALL_OK (DCF77_MINUTE_OK+DCF77_HOUR_OK+DCF77_DAY_OK+DCF77_WEEKDAY_OK+DCF77_MONTH_OK+DCF77_YEAR_OK)


uint8_t DCF77lastValid;


void DCF77_Start (void);
void DCF77_ISR_Trigger (void);
void DCF77_Stop (void);


#endif