/**
* \file
* lcdDogM.h
* \brief
* access LCD display DogM 1x8
*/


#ifndef _LCDDOGM_H
#define _LCDDOGM_H


#include "spi.h"


#define ROWLENGTH 0x40
#define ROWCOUNT 1


#define DOGM_PWR PD5
#define DOGM_PWRLED PD6
#define DOGM_DDRPWR DDRD
#define DOGM_PORTPWR PORTD
// SPI interface with different names
//#define DOGM_CLK SPI_SCK
//#define DOGM_SI SPI_MOSI
#define DOGM_RS PB0
#define DOGM_DDRRS DDRB
#define DOGM_PORTRS PORTB
#define DOGM_CSB PD7
#define DOGM_DDRCSB DDRD
#define DOGM_PORTCSB PORTD


void SPIenable (void);
void SPIdisable (void);

void DOGM_Start ();

void DOGM_Stop (void);

void DOGM_LED_On (void);

void DOGM_LED_Off (void);

void DOGM_WriteStringAddr (uint8_t line, uint8_t row, char *str);

void DOGM_WriteString (char *str);

void DOGM_WriteHello (void);

void DOGM_SetCursor (uint8_t line, uint8_t row);



#endif