/*
* AlarmClockV1.c
*
* Created: 12.12.2012 00:11:34
*  Author: mga
*/


#include "global.h"
//#include <stdint.h>
//#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/sleep.h>
#include "rtc.h"
#include "lcdDogM.h"
#include "taskScheduler.h"
#include "taskHandler.h"
#include "dcf77.h"
#include "tsic.h"
#include "controls.h"
#include "menu.h"
#include "alarm.h"



int main(void)
{
    AC_stat = FALSE;
    vddSolar == 999;
    vddBatt == 999;
    
    /* Clear WDRF in MCUSR */
    MCUSR &= ~(1<<WDRF);
    /* Write logical one to WDCE and WDE */
    /* Keep old prescaler setting to prevent unintentional time-out */
    WDTCSR |= (1<<WDCE) | (1<<WDE);
    /* Turn off WDT */
    WDTCSR = 0x00;

    // LED blink after reset
    LED_On();
    _delay_ms(2000);
    LED_Toggle();
    _delay_ms(200);
    LED_Toggle();

    TASKscheduler_Init();
    TASKhandler_Init();
    DOGM_Start ();
    DOGM_WriteHello();
    RTC_Timer2Init();
    CONTROLS_Init();
    MENU_Init();

    LED_Toggle();
    _delay_ms(500);
    LED_Toggle();
    _delay_ms(500);
    LED_Toggle();

    set_sleep_mode(SLEEP_MODE_PWR_SAVE);

    sei();

    while(1)
    {
        //LED_PORT &= ~(1 << LED_GREEN);
        sleep_mode();
        //LED_PORT |= (1 << LED_GREEN);

        // if TSic is active, the communication should not be interrupted by other application
        // however, it is overruled by RTC tic
        if (!(AC_stat & TSIC_ACTIVE) || !(AC_stat & BUZZER_ACTIVE) || AC_stat & RTC_TIC)
        {
            cli();

            while (TASKhandler_ExecNext() != TASK_QUEUE_EMPTY)
            {
            };

            if ((AC_stat & RTC_TIC) || (AC_stat & CONTROLS_TRIGGER))
            {
                MENU_Tic();
                AC_stat &= ~CONTROLS_TRIGGER;
                AC_stat &= ~RTC_TIC;
            }
            sei();
        }
    }
}




ISR(TIMER2_OVF_vect)
{
    AC_stat |= RTC_TIC;
    TASKhandler_AddTask(RTC_ISR_Trigger);

    // do once a second
    if (tic == 0)
    {
        TASKhandler_AddTask(TASKscheduler_Tic);
    }
}


ISR(PCINT1_vect)
{
    TASKhandler_AddTask(CONTROLS_ISR_Trigger);
}


ISR(PCINT2_vect)
{
    TASKhandler_AddTask(DCF77_ISR_Trigger);
}


ISR(INT1_vect)
{
    TSIC_ISR_Trigger();
}


ISR(TIMER1_COMPA_vect)
{
    static uint8_t xxx = 0;

    xxx++;

    if( (xxx % (2 + 2*tic)) == 0)
    {
        BUZZER_PORT ^= (1 << BUZZER_P);
    }



}