
#include "global.h"
#include "taskHandler.h"



pFunc tasksHdlr[TASKHANDLER_SIZE];
static uint8_t idxTaskBegin;
static uint8_t idxTaskEnd;


void TASKhandler_Init(void)
{
    idxTaskBegin = 0; // pointer to first task
    idxTaskEnd = 0; // pointer to next after last task
}


void IncPos (uint8_t *pIndex)
{
    *pIndex = *pIndex + 1;
    if (*pIndex > (TASKHANDLER_SIZE - 1))
    {
        *pIndex = 0;
    }
}


void TASKhandler_AddTask(pFunc pAddFunc)
{
    uint8_t idxTmp = idxTaskEnd;
    IncPos(&idxTmp);
    if (idxTmp == idxTaskBegin)
    {
        // queue full, force to execute the next task
        TASKhandler_ExecNext();
    }
    tasksHdlr[idxTaskEnd] = pAddFunc;
    idxTaskEnd = idxTmp;
}


uint8_t TASKhandler_ExecNext(void)
{
    if (idxTaskBegin != idxTaskEnd)
    {
        tasksHdlr[idxTaskBegin]();
        IncPos(&idxTaskBegin);
        return TASK_EXECUTED;
    }
    return TASK_QUEUE_EMPTY;
}
