/**
* \file
* tsic.h
* \brief
* access the temperature measurement module TSic 306 via ZACwire
*/


#ifndef _TSIC_H
#define _TSIC_H


#define TSIC_PWR PD1
#define TSIC_DDRPWR DDRD
#define TSIC_PORTPWR PORTD
#define TSIC_IRQ PD3 //INT1/PCINT19 (in case of a change, c-file needs to be changed, too)
#define TSIC_DDRIRQ DDRD
#define TSIC_PORTIRQ PORTD
#define TSIC_PINIRQ PIND

#define TSIC_BITCOUNT 20


void TSIC_Start (void);
void TSIC_ISR_Trigger (void);
void TSIC_Stop (void);

#endif